.486
.model flat, stdcall
option casemap :none
  
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\advapi32.inc
include \masm32\include\Comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\shell32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\ole32.inc
include \masm32\include\dialogs.inc
include \masm32\include\winmm.inc
include \masm32\include\msimg32.inc


includelib \masm32\lib\masm32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\Comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\winmm.lib
includelib \masm32\lib\msimg32.lib

include \masm32\MACROS\MACROS.asm

WndProc PROTO :DWORD, :DWORD, :DWORD, :DWORD

.const 
IDI_ICON    equ 200
IDD_DLG1    equ 101
TIMER1      equ 1
Stars       equ 200 ; number of stars

.data
szTitle      db 'Starfiled_rotation with resource example', 0   

MyRect      RECT <0,0,PictureW,PictureH>
noir            dd 0000000h
pt              dd Stars dup (0,0,0) ;x,y,z+color
scale           REAL4 0.01
scale_add       REAL4 0.005
ptX             dd 0
ptY             dd 0
tempX           dd 0
tempY           dd 0
random          dd 0
num256          REAL4 256.00
   
.data?
hInstance       dd ? 
hIcon     HICON     ?
hmainDC         dd ?  
hmainbmp    dd ? 
WindowRect      RECT     <?>
rect          RECT       <?>
rClientWindow   RECT     <?>
hbmp         HANDLE       ?
chdc         HDC          ?

PictureW       dd ?
PictureH       dd ?
hDialog       HWND ?

.code
start:
   
   
mov hInstance,rv(GetModuleHandle,0)
mov hInstance, eax
INVOKE InitCommonControls  

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR WndProc, 0
INVOKE ExitProcess, 0

WndProc PROC   uses edx ecx ebx esi edi  hWnd :HWND,uMsg :DWORD,wParam :DWORD,lParam :DWORD
LOCAL hdc:HDC
LOCAL ps:PAINTSTRUCT


 mov eax, uMsg  
   .IF eax == WM_INITDIALOG
 INVOKE SetWindowText, hWnd, addr szTitle 
 INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
 
INVOKE  GetClientRect,hWnd,ADDR rect
 m2m PictureW,rect.right
 m2m PictureH,rect.bottom
 
invoke CreateSolidBrush,noir
mov noir,eax
invoke SetTimer, hWnd, TIMER1, 10, NULL
;  main
 invoke GetDC, hWnd
 mov hdc, eax

 mov esi,PictureW
 mov edi,PictureH

invoke CreateCompatibleDC, hdc
mov dword ptr [hmainDC],eax

invoke CreateCompatibleBitmap, hdc, esi, edi
  mov dword ptr [hmainbmp],eax

invoke SelectObject, [hmainDC], eax

 invoke ReleaseDC,hWnd, hdc
 ;  main  
; -------------------------------------------------------------------------
.ELSEIF eax == WM_TIMER
xor esi,esi
;invoke GetClientRect,hWnd,ADDR rect
invoke FillRect, hmainDC, addr MyRect,noir
invoke RedrawWindow, hWnd, addr MyRect, 0, RDW_INVALIDATE	
@starfield:
call starfield
call rotation2D
invoke SetPixel, hmainDC, ptX, ptY, eax 
add esi,12       ; next stars
cmp esi,Stars*12 ; end?
jne @starfield 
invoke InvalidateRect,hWnd,0,0

   
; -------------------------------------------------------------------------
; ====================================  Create stars coord.
invoke GetTickCount
mov random,eax

xor esi,esi

CREATE_STARS:

push eax

imul ax,cx
movsx eax,ax
mov edx,eax
shr edx,8
mov ah,dh
add al,3
mov dword ptr [pt+esi],eax

pop eax
xor eax,[$+esi]
movsx eax,ax
mov edx,eax
shr edx,8
mov ah,dh
mov dword ptr [pt+esi+4], eax


imul ax,cx
xor ax,si
mov random,eax


mov ecx,eax
mov ch,1
and ecx,0fffh
mov dword ptr [pt+esi+8], ecx

add esi,12
cmp esi,Stars*12
jne CREATE_STARS

; ====================================  Create stars coord.
; -------------------------------------------------------------------------
.ELSEIF eax == WM_PAINT
mov hdc,rv(BeginPaint,hWnd,ADDR ps)
invoke GetClientRect,hWnd,ADDR rect
fld scale_add
fld scale
faddp st(1),st
fstp scale
invoke BitBlt,hdc,0,0, PictureW,PictureH,hmainDC,0,0,SRCCOPY
invoke EndPaint,hWnd,addr ps

; -------------------------------------------------------------------------
; -------------------------------------------------------------------------

.ELSEIF  uMsg == WM_KEYDOWN
.ELSEIF wParam == VK_ESCAPE
INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0 
; -------------------------------------------------------------------------


; -------------------------------------------------------------------------
    .ElseIf eax == WM_LBUTTONDOWN
		invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0     
; -------------------------------------------------------------------------         
   .ELSEIF eax == WM_CLOSE || uMsg == WM_RBUTTONUP
      destroy:
      invoke PostQuitMessage,NULL
      invoke DeleteDC, [hmainDC]
      invoke DeleteObject, [hmainbmp]
      invoke DeleteObject, noir
      invoke KillTimer, hWnd, TIMER1
      INVOKE EndDialog,hWnd, 0
   .ENDIF
   
   xor eax,eax
   ret
; -------------------------------------------------------------------------
   
; -------------------------------------------------------------------------   
starfield:

finit

dec dword ptr [pt+esi+8]

fild word ptr [pt+esi+8] ;z
fld  num256

fild dword ptr [pt+esi] ;x
fmul st(0),st(1)
fdiv st(0),st(2)
fistp dword ptr [tempX]


fild dword ptr [pt+esi+4] ;y
fmul st(0),st(1)
fdiv st(0),st(2)
fistp dword ptr [tempY]


xor eax,eax
mov al,byte ptr [pt+esi+8+4] ; color
mov ah,al
shl eax,8
mov al,ah


.IF byte ptr [pt+esi+8+3] != 0FFh ; color white max
      inc byte ptr [pt+esi+8+3]
      .ENDIF


retn

; -------------------------------------------------------------------------
; -------------------------------------------------------------------------
CHANGE_STARS:                    ;change stars coord.

mov eax, random

push eax

imul ax,cx
movsx eax,ax
mov edx,eax
shr edx,8
mov ah,dh
add al,3
mov dword ptr [pt+esi],eax

pop eax
xor eax,[$+esi]
movsx eax,ax
mov edx,eax
shr edx,8
mov ah,dh
mov dword ptr [pt+esi+4], eax


imul ax,cx
xor ax,si
mov random,eax


mov ecx,eax
mov ch,1
and ecx,00FFFFFFh
mov dword ptr [pt+esi+8], ecx ; fface z et raz la couleur

retn
; -------------------------------------------------------------------------

; 
rotation2D:

finit

fld scale
fsin
fild dword ptr [tempY]  ;Y
fmul st(0),st(1)
fld scale
fcos
fild dword ptr [tempX] ;X
fmul st(0),st(1)
fsub st(0),st(2)
fistp dword ptr [ptX]


fld scale
fcos
fild dword ptr [tempY] ;Y
fmul st(0),st(1)
fld scale
fsin
fild dword ptr [tempX]  ;X
fmul st(0),st(1)
fadd st(0),st(2)
fistp dword ptr [ptY]



  mov     eax,PictureW
      shr     eax,1
      add     ptX,eax ; center
   mov     eax,PictureH
      shr     eax,1
      add     ptY,eax
.if ptX > ecx || ptY > edx
call CHANGE_STARS
.ENDIF

retn   
; -------------------------------------------------------------------------
WndProc ENDP

END start